load stopi.mat;

sigma   = 1.50;                     % utility parameter
delta   = 0.10;                     % depreciation rate
beta    = 0.95;                     % discount factor
alpha   = 0.30;                     % capital elasticity of output
p		= 0.9;
PI		= [p 1-p;1-p p];
se		= 0.2;
ab		= 0;
am		= exp(ab-se);
as		= exp(ab+se);
A=[am as];
nba=2;

nbk     = 1000;                     % number of data points in the grid
crit    = 1;                        % convergence criterion
iter    = 1;                        % iteration
epsi    = 1e-6;                     % convergence parameter

kmin    = 0.2;               			% lower bound on the grid
kmax    = 6;               			% upper bound on the grid

transk	= 2*(kgrid-kmin)/(kmax-kmin)-1;

n			= 8;
Tk			= [ones(nbk,1) transk];
for i=3:n;
   Tk=[Tk 2*transk.*Tk(:,i-1)-Tk(:,i-2)];
end
b=Tk\kp;

long=200;
[a,id]=markov(PI,A,long,1);

k0=2.6;

k=zeros(long+1,1);
y=zeros(long,1);
k(1)=k0;
for t=1:long;
   trkt=2*(k(t)-kmin)/(kmax-kmin)-1;
   Tk			= [1 trkt];
   for i=3:n;
      Tk=[Tk 2*trkt.*Tk(:,i-1)-Tk(:,i-2)];
   end
   
   k(t+1)=Tk*b(:,id(t));
y(t)=A(id(t))*k(t).^alpha;
   
end

i=k(2:long+1)-(1-delta)*k(1:long);
c=y-i;

subplot(221);plot(1:long,k(1:long));
set(gca,'fontname','times','fontsize',12);
xlabel('Time','fontname','times','fontsize',12);
title('Capital stock','fontname','times','fontsize',12);
subplot(222);plot(1:long,i);
set(gca,'fontname','times','fontsize',12);
xlabel('Time','fontname','times','fontsize',12);
title('Investment','fontname','times','fontsize',12);
subplot(223);plot(1:long,y);
set(gca,'fontname','times','fontsize',12);
xlabel('Time','fontname','times','fontsize',12);
title('Output','fontname','times','fontsize',12);
subplot(224);plot(1:long,c);
set(gca,'fontname','times','fontsize',12);
xlabel('Time','fontname','times','fontsize',12);
title('Consumption','fontname','times','fontsize',12);
pause;
print -depsc2 simogm.eps
close