clear all
%
% Solve the stochastic OGM by value iteration
%
% a bit more efficient
%
sigma	= 1.5;
delta	= 0.1;
beta	= 0.95;
alpha	= 0.30;
p		= 0.9;
PI		= [p 1-p;1-p p];
se		= 0.2;
ab		= 0;
am		= exp(ab-se);
as		= exp(ab+se);
A=[am as];
nba=2;

ks		= ((1-beta*(1-delta))/(alpha*beta))^(1/(alpha-1));
csy	= 1-alpha*beta*delta/(1-beta*(1-delta));
dev	= 0.9;
kmin	= 0.2;(1-dev)*ks;
kmax	= 6;(1+dev)*ks;
nbk	= 1000;
devk	= (kmax-kmin)/(nbk-1);
k		= linspace(kmin,kmax,nbk)';
c		= zeros(nbk,nba);
u		= zeros(nbk,nba);
v		= zeros(nbk,nba);
Tv		= zeros(nbk,nba);
iter	= 1;
crit	= 1;
tol	= 1e-6;

for j=1:nba;
   c			= repmat(A(j)*k'.^alpha+(1-delta)*k',nbk,1)-repmat(k,1,nbk);
   neg		= find(c<=0);     
   c(neg)	= NaN;
   eval(['util' int2str(j) '= (c.^(1-sigma)-1)/(1-sigma);'])
   eval(['util' int2str(j) '(neg)= -inf;'])
   clear c neg;
end
while crit>tol;
   for j=1:nba;
      eval(['[vtmp,drtmp]	= max(util' int2str(j) '+beta*repmat(v*PI(j,:)'',1,nbk));']);
      Tv(:,j)=vtmp';
      dr(:,j)=drtmp';
   end
   crit	= max(max(abs(Tv-v)));
   v		= Tv;
   iter	= iter+1;
end

kp		= k(dr);
for j=1:nba;
   c(:,j)	= A(j)*k.^alpha+(1-delta)*k-kp(:,j);
end

subplot(221);h=plot(k,kp);
set(h,'color','k','linewidth',1);
axis([0 kmax 0 kmax])
xlim=get(gca,'xlim');
ylim=get(gca,'ylim');
h=line(xlim,ylim);
set(h,'color','k','linestyle','--');
xlabel('k_t','fontname','times','fontsize',12)
title('Next period capital stock','fontname','times','fontsize',12)
set(gca,'fontname','times','fontsize',12)
c=zeros(nbk,nba);
for j=1:nba;
   c(:,j)	= A(j)*k.^alpha+(1-delta)*k-kp(:,j);
end

subplot(222);plot(k,c,'color','k','linewidth',1);
xlabel('k_t','fontname','times','fontsize',12)
title('Consumption','fontname','times','fontsize',12)
set(gca,'fontname','times','fontsize',12)
pause
print -depsc2 drstovi.eps
close

plot(k,v,'color','g','linewidth',2);
xlabel('k_t','fontname','times','fontsize',14)
set(gca,'fontname','times','fontsize',14)

pause
print -depsc2 vfstovi.eps
close